<?php
/*
This file is part of Silex - see http://projects.silexlabs.org/?/silex

Silex is © 2010-2011 Silex Labs and is released under the GPL License:

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License (GPL) as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
class StringTools {
	public function __construct(){}
	static function urlEncode($s) {
		return rawurlencode($s);
		;
	}
	static function urlDecode($s) {
		return urldecode($s);
		;
	}
	static function htmlEscape($s) {
		return _hx_explode(">", _hx_explode("<", _hx_explode("&", $s)->join("&amp;"))->join("&lt;"))->join("&gt;");
		;
	}
	static function htmlUnescape($s) {
		return htmlspecialchars_decode($s);
		;
	}
	static function startsWith($s, $start) {
		return (strlen($s) >= strlen($start) && _hx_substr($s, 0, strlen($start)) === $start);
		;
	}
	static function endsWith($s, $end) {
		$elen = strlen($end);
		$slen = strlen($s);
		return ($slen >= $elen && _hx_substr($s, $slen - $elen, $elen) === $end);
		unset($slen,$elen);
	}
	static function isSpace($s, $pos) {
		$c = _hx_char_code_at($s, $pos);
		return ($c >= 9 && $c <= 13) || $c === 32;
		unset($c);
	}
	static function ltrim($s) {
		return ltrim($s);
		;
	}
	static function rtrim($s) {
		return rtrim($s);
		;
	}
	static function trim($s) {
		return trim($s);
		;
	}
	static function rpad($s, $c, $l) {
		return str_pad($s, $l, $c, STR_PAD_RIGHT);
		;
	}
	static function lpad($s, $c, $l) {
		return str_pad($s, $l, $c, STR_PAD_LEFT);
		;
	}
	static function replace($s, $sub, $by) {
		return str_replace($sub, $by, $s);
		;
	}
	static function hex($n, $digits) {
		$s = dechex($n);
		if($digits !== null) {
			$s = str_pad($s, $digits, "0", STR_PAD_LEFT);
			;
		}
		return strtoupper($s);
		unset($s);
	}
	function __toString() { return 'StringTools'; }
}
