<?php
/*
This file is part of Silex - see http://projects.silexlabs.org/?/silex

Silex is  2010-2011 Silex Labs and is released under the GPL License:

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License (GPL) as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
class org_silex_ui_Text extends org_silex_ui_UiBase {
	public function __construct() {
		if( !php_Boot::$skip_constructor ) {
		parent::__construct();
		;
	}}
	public $html;
	public $htmlText;
	public $embedFonts;
	public $cssUrl;
	public $scrollBar;
	public $typeWriterEffectSpeed;
	public $scrollbarWidth;
	public $selectable;
	public $multiline;
	public $textColor;
	public $textHeight;
	public $autoSize;
	public $border;
	public $borderColor;
	public $antiAliasType;
	public $background;
	public $backgroundColor;
	public $condenseWhite;
	public $maxChars;
	public $mouseWheelEnabled;
	public $password;
	public $restrict;
	public $wordWrap;
	public $textFormat;
	public function returnHTML() {
		$textToRet = null;
		$scrollBars = "";
		if($this->html) {
			$tmp = htmlspecialchars_decode($this->htmlText);
			$tmp = ("<rootnode>" . $tmp) . "</rootnode>";
			$textToRet = org_silex_ui_Text::fromFlashToHTML(Xml::parse($tmp)->firstElement())->toString();
			unset($tmp);
		}
		else {
			$textToRet = $this->htmlText;
			;
		}
		if($this->scrollBar) {
			$scrollBars = "overflow:auto;";
			;
		}
		else {
			$scrollBars = "overflow:hidden;";
			;
		}
		return ((((((((("<div style='" . $scrollBars) . "width:") . $this->width) . "px;height:") . $this->height) . "px;' debug='") . Std::string($this->html)) . "'>") . $textToRet) . "</div>";
		unset($textToRet,$scrollBars);
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->dynamics[$m]) && is_callable($this->dynamics[$m]))
			return call_user_func_array($this->dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call '.$m.'');
	}
	static function fromFlashToHTML($node) {
		$resultingNode = null;
		switch(strtolower($node->getNodeName())) {
		case "textformat":{
			$resultingNode = Xml::createElement("span");
			;
		}break;
		case "p":{
			$resultingNode = Xml::createElement("p");
			$resultingNode->set("style", "margin:0px");
			;
		}break;
		case "font":{
			$resultingNode = Xml::createElement("span");
			;
		}break;
		case "b":{
			$resultingNode = Xml::createElement("span");
			$resultingNode->set("style", "font-weight:bold");
			;
		}break;
		case "u":{
			$resultingNode = Xml::createElement("span");
			$resultingNode->set("style", "text-decoration:underline");
			;
		}break;
		case "i":{
			$resultingNode = Xml::createElement("span");
			$resultingNode->set("style", "font-style:italic");
			;
		}break;
		case "li":{
			$resultingNode = Xml::createElement("li");
			;
		}break;
		default:{
			$resultingNode = Xml::createElement("span");
			;
		}break;
		}
		if(null == $node) throw new HException('null iterable');
		$it = $node->attributes();
		while($it->hasNext()) {
		$attr = $it->next();
		{
			switch(strtolower($attr)) {
			case "align":{
				$resultingNode->set("style", (($resultingNode->get("style") . ";") . "text-align:") . $node->get($attr));
				;
			}break;
			case "face":{
				$resultingNode->set("style", (($resultingNode->get("style") . ";") . "font-family:") . $node->get($attr));
				;
			}break;
			case "size":{
				$resultingNode->set("style", ((($resultingNode->get("style") . ";") . "font-size:") . $node->get($attr)) . "px");
				;
			}break;
			case "color":{
				$resultingNode->set("style", (($resultingNode->get("style") . ";") . "color:") . $node->get($attr));
				;
			}break;
			case "letterspacing":{
				null;
				;
			}break;
			default:{
				null;
				;
			}break;
			}
			;
		}
		}
		if(null == $node) throw new HException('null iterable');
		$it = $node->iterator();
		while($it->hasNext()) {
		$cn = $it->next();
		{
			if($cn->nodeType == Xml::$CData || $cn->nodeType == Xml::$PCData) {
				$resultingNode->addChild(Xml::createPCData($cn->getNodeValue()));
				;
			}
			else {
				if($cn->nodeType == Xml::$Element) {
					$resultingNode->addChild(org_silex_ui_Text::fromFlashToHTML($cn));
					;
				}
				;
			}
			;
		}
		}
		return $resultingNode;
		unset($resultingNode);
	}
	function __toString() { return 'org.silex.ui.Text'; }
}
